<?php

namespace Drupal\monarch_bootstrap;

/**
 * Store globals for general use.
 *
 * This should probably be a service, but themes don't support services.
 */
class Globals {

  /**
   * The collected global variables.
   *
   * @var array
   */
  private static $globals = NULL;

  /**
   * Get global variables for all twig templates to play with.
   *
   * @return object
   *   The globals to use.
   */
  public static function &getGlobals() {
    if (empty(static::$globals)) {
      static::$globals = (object) [];

      static::$globals->routeParameters = [];
      static::$globals->routeParameterKeys = [];

      $route_match = \Drupal::routeMatch();

      foreach ($route_match->getParameters()->keys() as $key) {
        static::$globals->routeParameterKeys[] = $key;
        $value = static::$globals->routeParameters[$key] = $route_match->getParameter($key);

        if (!isset(static::$globals->routeEntity) && !empty($value) && method_exists($value, 'getEntityTypeId')) {
          static::$globals->routeEntity = $value;
        }
      }

      static::$globals->routeEntity = static::$globals->routeEntity ?? NULL;
    }

    return static::$globals;
  }

}
